#!/bin/bash

analyse () {

RESUMFILE=`basename $1`
PWWD=`dirname $1`

$PWD/analyse_resum_file.awk $1 > temp.$$

cat temp.$$

NMK=`cat $1 | awk ' BEGIN {FS="="} "NB_MARKER"  == $1 { print $2 }'`
POSQTL=`cat $1 | awk ' BEGIN {FS="="} "POS_QTL" == $1 { print $2 }'`
EFF_QTL=`cat $1 | awk ' BEGIN {FS="="} "EFF_QTL"  == $1 { print $2 }'`
H2=`cat $1 | awk ' BEGIN {FS="="} "H2" == $1 { print $2 }'`
RATIO_POLQTL=`cat $1 | awk ' BEGIN {FS="="} "RATIO_POLQTL"  == $1 { print $2 }'`
NG=`cat $1 | awk ' BEGIN {FS="="} "NG" == $1 { print $2 }'`
NMPED=`cat $1 | awk ' BEGIN {FS="="} "NMPED"  == $1 { print $2 }'`
NFMPED=`cat $1 | awk ' BEGIN {FS="="} "NFMPED" == $1 { print $2 }'`
NDFPED=`cat $1 | awk ' BEGIN {FS="="} "NDFPED"  == $1 { print $2 }'`
NMQTL=`cat $1 | awk ' BEGIN {FS="="} "NMQTL" == $1 { print $2 }'`
NFMQTL=`cat $1 | awk ' BEGIN {FS="="} "NFMQTL"  == $1 { print $2 }'`
NDFQTL=`cat $1 | awk ' BEGIN {FS="="} "NDFQTL" == $1 { print $2 }'`
QTLMAP_H2=`cat $1 | awk ' BEGIN {FS="="} "QTLMAP_H2"  == $1 { print $2 }'`
QTLMAP_NSIM=`cat $1 | awk ' BEGIN {FS="="} "QTLMAP_NSIM" == $1 { print $2 }'`

T1=`cat temp.$$ | awk ' BEGIN {FS="="} "t1" == $1 { print $2 }'`
T2=`cat temp.$$ | awk ' BEGIN {FS="="} "t2" == $1 { print $2 }'`
T3=`cat temp.$$ | awk ' BEGIN {FS="="} "t3" == $1 { print $2 }'`
T4=`cat temp.$$ | awk ' BEGIN {FS="="} "t4" == $1 { print $2 }'`
T5=`cat temp.$$ | awk ' BEGIN {FS="="} "t5" == $1 { print $2 }'`
T6=`cat temp.$$ | awk ' BEGIN {FS="="} "t6" == $1 { print $2 }'`
TOTAL=`cat temp.$$ | awk ' BEGIN {FS="="} "total" == $1 { print $2 }'`

MSEG=`cat temp.$$ | awk ' BEGIN {FS="="} "mseg" == $1 { print $2 }'`
MSE=`cat temp.$$ | awk ' BEGIN {FS="="} "mse" == $1 { print $2 }'`
NBSIM=`cat temp.$$ | awk ' BEGIN {FS="="} "nbsim" == $1 { print $2 }'`

cat temp.$$ | awk 'BEGIN {ok="n";} $0=="===== end ======" {ok="n"} ok=="y" { ii=-1000;for (i=1;i<=NF;i++) {print ii" "$i;ii++}} $0 == "===== samples.dat ======" {ok="y";}' > sample$$.data
cat temp.$$ | awk 'BEGIN {ok="n";} $0=="===== end2 ======" {ok="n"} ok=="y" { ii=-1000;for (i=1;i<=NF;i++) {print ii" "$i;ii++}} $0 == "===== samples2.dat ======" {ok="y";}' > sample2$$.data

#-0.5cM
nbd1=`cat sample$$.data | awk 'BEGIN {v=0;} $1 >= -5 && $1 < 0 {v=$2+v} END {print v;}'`
nbd2=`cat sample$$.data | awk '$1 == 0 {print $2}'`
#+0.5cM
nbd3=`cat sample$$.data | awk 'BEGIN {v=0;} $1 <= 5 && $1 > 0 {v=$2+v} END {print v;}'`

sumnbd=$(( $nbd1 + $nbd2 + $nbd3 ))

sumnbd2=`cat sample$$.data | awk 'BEGIN {v=0;} $1 <= 10 && $1 >= -10 {v=$2+v} END {print v;}'`

sumnbd3=`cat sample$$.data | awk 'BEGIN {v=0;} $1 <= 20 && $1 >= -20 {v=$2+v} END {print v;}'`

persumnbd=`awk 'BEGIN { print (( '$sumnbd' / '$NBSIM')*100) }'`
persumnbd2=`awk 'BEGIN { print (('$sumnbd2' / '$NBSIM')*100) }'`
persumnbd3=`awk 'BEGIN { print (('$sumnbd3' / '$NBSIM')*100) }'`

RAPPORT=$2/$PWWD
mkdir -p $RAPPORT
cp $1 $RAPPORT/


gnuplot <<EOF
set title "Ecart à la position réelle du qtl - $RESUMFILE (nbsim=$NBSIM)";
set term png size 1600,1200;
set output "$RAPPORT/$RESUMFILE.png";
set ylabel "NbSimul";
set xlabel "cMorgan";
set xrange [-500:500];
set yrange [0:100];
set style fill solid border -1;
set label sprintf("nmk=%i",$NMK) at 30,40;
set label sprintf("posiqtl=%1.3f",$POSQTL) at 30,41;
set label sprintf("effqtl=%1.3f",$EFF_QTL) at 30,42;
set label sprintf("h2=%1.3f",$H2) at 30,43;
set label sprintf("ratiopolqtl=%1.3f",$RATIO_POLQTL) at 30,44;
set label sprintf("ng=%i",$NG) at 30,45;
set label sprintf("nmped=%i",$NMPED) at 30,46;
set label sprintf("nfmped=%i",$NFMPED) at 30,47;
set label sprintf("ndfped=%i",$NDFPED) at 30,48;
set label sprintf("nmqtl=%i",$NMQTL) at 30,49;
set label sprintf("nfmqtl=%i",$NFMQTL) at 30,50;
set label sprintf("ndfqtl=%i",$NDFQTL) at 30,51;
set label sprintf("qtlmaph2=%1.3f",$QTLMAP_H2) at 30,52;
set label sprintf("nsimqtlmap=%i",$QTLMAP_NSIM) at 30,53;


set label sprintf("LRT Significatif (>0.1000)=%i",$T1) at 30,38;
set label sprintf("LRT Significatif (>0.0500)=%i",$T2) at 30,37;
set label sprintf("LRT Significatif (>0.0100)=%i",$T3) at 30,36;
set label sprintf("LRT Significatif (>0.0050)=%i",$T4) at 30,35;
set label sprintf("LRT Significatif (>0.0027)=%i",$T5) at 30,34;
set label sprintf("LRT Significatif (>0.0001)=%i",$T6) at 30,33;
set label sprintf("LRT Significatif (TOTAL)=%i",$TOTAL) at 30,32;

set label sprintf("MSE ($NBSIM simul) =%f",$MSEG) at 30,30;
set label sprintf("MSE Significatif ($TOTAL simul)=%f",$MSE) at 30,29;


set label sprintf("-0,005 cMorgan from true position = %i",$nbd1) at 30,16;
set label sprintf("true position                    = %i",$nbd2) at 30,17;
set label sprintf("+0,005 cMorgan from true position = %i",$nbd3) at 30,15;


set label sprintf("+-0.01 from the true position = %i (%2.1f\%)",$sumnbd,$persumnbd) at 30,13;
set label sprintf("+-0.02 from the true position = %i (%2.1f\%)",$sumnbd2,$persumnbd2) at 30,12;
set label sprintf("+-0.03 from the true position = %i (%2.1f\%)",$sumnbd3,$persumnbd3) at 30,11;


# Dessin de la courbe
plot 'sample$$.data' with boxes title 'Histogramme';
EOF

nbd1=`cat sample2$$.data | awk 'BEGIN {v=0;} $1 >= -10 && $1 < 0 {v=$2+v} END {print v;}'`
nbd2=`cat sample2$$.data | awk '$1 == 0 {print $2}'`
#+0.5cM
nbd3=`cat sample2$$.data | awk 'BEGIN {v=0;} $1 <= 10 && $1 > 0 {v=$2+v} END {print v;}'`

sumnbd=$(( $nbd1 + $nbd2 + $nbd3 ))

persumnbd=`awk 'BEGIN { print (( '$sumnbd' / '$NBSIM')*100) }'`


gnuplot <<EOF
set title "Ecart à la position réelle du qtl - $RESUMFILE (nbsim=$NBSIM)";
set term png size 1600,1200;
set output "$RAPPORT/${RESUMFILE}_2.png";
set ylabel "NbSimul";
set xlabel "cMorgan";
set xrange [-500:500];
set yrange [0:100];
set style fill solid border -1;

set label sprintf("-0,010 cMorgan from true position = %i",$nbd1) at 30,16;
set label sprintf("true position                    = %i",$nbd2) at 30,17;
set label sprintf("+0,010 cMorgan from true position = %i",$nbd3) at 30,15;


set label sprintf("+-0.01 from the true position = %i (%2.1f\%)",$sumnbd,$persumnbd) at 30,13;


# Dessin de la courbe
plot 'sample2$$.data' with boxes title 'Histogramme';
EOF


rm sample$$.data
rm sample2$$.data
rm temp.$$
}


list=`find NG* -name RESUM*`
DIRSAVE="SAVE_RESUME/`date +%y%m%d-%T`"
mkdir -p $DIRSAVE

#cp $list $DIRSAVE/
#list=./NG5_NMPED5_NFMPED4_NDFPED10_NMQTL5_NFMQTL10_NDFQTL10/H2_0.8_RATIO_POLQTL0.05_LONGCHROMO1.0_NMK200_POS_QTL0.5_EFF_QTL1.0/RESUME_CALCUL_NDMIN25_1500_STEP0.01_MODELH2_0.8_NSIMTHRESH1500_29
for file in $list
do
 echo "$file"
 analyse $file $DIRSAVE
done


