      implicit none

      integer ng,nmped,nfmped,ndfped,nmqtl,nfmqtl,ndfqtl
      integer nm,nf,nd,nfm,ndf
      integer ntot,nfped,nfqtl,ndescped,ndescqtl,ndesc 
      integer iseed
      integer indice,jeune,nbmale,nbfemelle,nbfinal
      integer i,j,k,l,ig,ipere,imere,retenu
      integer kflag,ier
      integer corr(1000000)

      real u(1)


      integer, allocatable :: id(:,:),jd(:,:)
      integer, allocatable :: tab(:),iperm(:),idig(:)
      integer, allocatable :: tmale(:,:),tfemelle(:,:),tfinal(:,:)
      real, allocatable ::  x(:)      
      
      open(1,file='parpop')
      open(2,file='pedig')
            
      read(1,*)ng,nmped,nfmped,ndfped,nmqtl,nfmqtl,ndfqtl
      
!  ng = nombre de gnrations
!  nmped = nombre de males "historiques"
!  nfmped = nombre de femelles / male "historiques"
!  ndfped = nombre de descendants/femelle "historiques"
!  nmqtl = nombre de males du protocole QTL
!  nfmqtl = nombre de femelles du protocole QTL
!  ndfqtl = nombre de descendants / femelle du protocole QTL
!
      read(1,*)iseed
      ntot=ng*(nmped*(1+nfmped))+nmqtl*(1+nfmqtl*(1+ndfqtl))
      nfped=nmped*nfmped
      nfqtl=nmqtl*nfmqtl      
      ndescped=nmped*nfmped*ndfped
      ndescqtl=nmqtl*nfmqtl*ndfqtl
      
      if(nfqtl .gt.(0.5*ndescped)) then
        print*,'effectif historique trop faible pour le protocole'
	stop
      end if
                 
      allocate (id(ntot,3))
      allocate (jd(ntot,3))
      allocate (tab(3*ntot))
      allocate (iperm(3*ntot))     
      allocate (tmale(ndescped,3))
      allocate (tfemelle(ndescped,3))
      allocate (tfinal(ndescqtl,3) )
      allocate (x(max(ndescped,ndescqtl))) 

      ! ajout ofi pour ecrire le numero de generation dans pedig
      allocate (idig((ng+1)*10000))
           
      id=0
      tmale=0
      tfemelle=0
			
! indice est la position dans PEDIG du nouvel animal  entrer	
!
! id est le fichier pedig : une ligne = identit de l'individu et ses parents
! les identits sont fabriqus par (numro de gnration) * 10000 + (ordre intra gnration)
!
!  on commence par entrer les id des fondateur			
      indice=0
      do i=1,nmped
        indice=indice+1
        id(indice,1)=10000+i
        idig(indice)=1
      end do
      do j=1,nfped
        indice=indice+1
        id(indice,1)=10000+nmped+j
        idig(indice)=1
      end do   
!
!  ici connence la boucle sur les ng+2 gnrations
!
!  les gnrations historiques se faont avec les effectifs nm, nf et ra
      nm=nmped
      nf=nfped
      ndf=ndfped
      nfm=nfmped
	
      ig=1
      do while (ig < ng+2)
        ig=ig+1
!
!  on gnre les nouveaux
!
!  les femelles des la gnration ig-1 sont permutes pour attributions aux conjoints
!
!  trans est le tableau des identits avant slection
!
        call ranper(nf,iseed,x)
	jeune=ig*10000
	nbmale=0
	nbfemelle=0
	nbfinal=0
        do i=1,nm
	  ipere=indice-nm-nf+i
	  do j=1,nfm
	    imere=indice-nf+int(x(nfm*(i-1)+j))
	    do k=1,ndf
	      jeune=jeune+1
	      if(ig.lt.ng+2)then 
	        call uniran(1,iseed,u)
	        if(u(1).le.0.5) then
	          nbmale=nbmale+1
	          tmale(nbmale,1)=jeune
	          tmale(nbmale,2)=id(ipere,1)
	          tmale(nbmale,3)=id(imere,1)
	        else
	          nbfemelle=nbfemelle+1
	          tfemelle(nbfemelle,1)=jeune
	          tfemelle(nbfemelle,2)=id(ipere,1)
	          tfemelle(nbfemelle,3)=id(imere,1)	      
	        end if	
	      else  ! dernire gnration
	        nbfinal=nbfinal+1
	        tfinal(nbfinal,1)=jeune
	        tfinal(nbfinal,2)=id(ipere,1)
	        tfinal(nbfinal,3)=id(imere,1)
              end if 	      
	    end do !k
	  end do !j
	end do !i

	if(ig.eq.ng+1) then
          nm=nmqtl
          nf=nfqtl
          ndf=ndfqtl
          nfm=nfmqtl
	end if
	
	if(ig.lt.ng+2) then
!
!  on garde cet chantillon si les nombres de descendants par sexes sont suffisants
!  
          if(nbmale.ge.nm.and.nbfemelle.ge.nf)then

!
!  selection des reproducteurs
!  on prend les nm premier d'une permutation des males ns
!  puis les nf premires des permutations des femelles nes
!
            call ranper(nbmale,iseed,x)
            do i=1,nm
	      indice=indice+1
	      retenu=x(i)
              idig(indice)=ig
	      do l=1,3
	        id(indice,l)=tmale(retenu,l)
	      end do !l
	    end do !i
       	      
            call ranper(nbfemelle,iseed,x)
            do i=1,nf
	      indice=indice+1
              idig(indice)=ig
	      retenu=x(i)
	      do l=1,3
	        id(indice,l)=tfemelle(retenu,l)
	      end do !l
            end do !i
	 
          else
!  on annule cet chantillon si les effectifs sont insuffisants       
            ig=ig-1
            nm=nmped
            nf=nfped
            ndf=ndfped
            nfm=nfmped	  
          end if ! test de nbmale et nbfemelle
	  
	else  ! dernire gnration
            do k=1,ndescqtl
	      indice=indice+1
              idig(indice)=ig
	      do l=1,3
	        id(indice,l)=tfinal(k,l)
	      end do !l
	    end do !i
	    
       	end if ! test de ig    
       
      end do ! ig
 
!
!  recodification
!      

      j=1
      do i=1,indice
        tab(j)=id(i,1)
        tab(j+1)=id(i,2)
        tab(j+2)=id(i,3)
        j=j+3
      end do !i
      j=j-1
      
      
      kflag=1
      call ipsort(tab,j,iperm,kflag,ier) 
      
      corr(1)=0
      k=1      
      do i=2,j
        if(tab(iperm(i)).ne.0)then
	  if(tab(iperm(i)).ne.tab(iperm(i-1))) then
	    corr(tab(iperm(i)))=k  
	    k=k+1
	  end if
	end if
      end do  
   
 
!
!  tri puis transfert dans le fichier PEDIG
! 
 
      do i=1,indice
        tab(i)=id(i,1)
      end do !i
      kflag=1
      call ipsort(tab,indice,iperm,kflag,ier)
      do i=1,indice
        do l=1,3
          jd(i,l)=id(iperm(i),l)
        end do  !k          
      end do  !i

      do i=1,indice
        write(2,200) (corr(jd(i,l)),l=1,3),(idig(corr(jd(i,1)))-ng)
  200   format(3(i6,1x),i6)
      end do !i
      
      stop
      end     	
	
	
	
	
      SUBROUTINE RANPER(N,ISTART,X)

      DIMENSION X(1)
      DIMENSION U(1)
C
      AN=N

      DO100I=1,N
      X(I)=I
  100 CONTINUE
C
      DO200I=1,N
      CALL UNIRAN(1,istart,U)
      ADD=AN*U(1)+1.0
      IADD=ADD
      IF(IADD.LT.1)IADD=1
      IF(IADD.GT.N)IADD=N
      J=I+IADD
      IF(J.GT.N)J=J-N
      HOLD=X(J)
      X(J)=X(I)
      X(I)=HOLD
  200 CONTINUE
      RETURN
      END 
      
      
            SUBROUTINE UNIRAN(N,ISEED,X)

      DIMENSION X(*)
      DIMENSION M(17)
      SAVE I,J,M,M1,M2
C
      DATA M(1),M(2),M(3),M(4),M(5),M(6),M(7),M(8),M(9),M(10),M(11),
     1     M(12),M(13),M(14),M(15),M(16),M(17)
     1/    30788,23052,2053,19346,10646,19427,23975,
     1     19049,10949,19693,29746,26748,2796,23890,
     1     29168,31924,16499/ 
      DATA M1,M2,I,J / 32767,256,5,17 / 
C
      IPR=6

      IF(ISEED.LE.0)GOTO290
C
      MDIG=32
C
      M1=2**(MDIG-2)+(2**(MDIG-2)-1)
      M2=2**(MDIG/2)
      ISEED3=IABS(ISEED)
      IF(M1.LT.IABS(ISEED))ISEED3=M1
      IF(MOD(ISEED3,2).EQ.0)ISEED3=ISEED3-1
      K0=MOD(9069,M2)
      K1=9069/M2
      J0=MOD(ISEED3,M2)
      J1=ISEED3/M2
C
      DO200I=1,17
      ISEED3=J0*K0
      J1=MOD(ISEED3/M2+J0*K1+J1*K0,M2/2)
      J0=MOD(ISEED3,M2)
      M(I)=J0+M2*J1 
  200 CONTINUE
C
      I=5 
      J=17
C
  290 CONTINUE
C
C
      DO300L=1,N
      K=M(I)-M(J)
      IF(K.LT.0)K=K+M1
      M(J)=K
      I=I-1
      IF(I.EQ.0)I=17
      J=J-1
      IF(J.EQ.0)J=17
      AK=K
      AM1=M1
      X(L)=AK/AM1
  300 CONTINUE
C
C
      ISEED=(-1)
C
C
 9000 CONTINUE
      RETURN
      END       


      SUBROUTINE IPSORT (IX, N, IPERM, KFLAG, IER)

C     .. Scalar Arguments ..
      INTEGER IER, KFLAG, N
C     .. Array Arguments ..
      INTEGER IPERM(*), IX(*)
C     .. Local Scalars ..
      REAL R
      INTEGER I, IJ, INDX, INDX0, ISTRT, ITEMP, J, K, KK, L, LM, LMT, M,
     +        NN
C     .. Local Arrays ..
      INTEGER IL(21), IU(21)
C     .. External Subroutines ..
      EXTERNAL XERMSG
C     .. Intrinsic Functions ..
      INTRINSIC ABS, INT
C***FIRST EXECUTABLE STATEMENT  IPSORT
      IER = 0
      NN = N

      KK = ABS(KFLAG)
 
C
C     Initialize permutation vector
C
      DO 10 I=1,NN
         IPERM(I) = I
   10 CONTINUE
C
C     Return if only one value is to be sorted
C
      IF (NN .EQ. 1) RETURN
C
C     Alter array IX to get decreasing order if needed
C
      IF (KFLAG .LE. -1) THEN
         DO 20 I=1,NN
            IX(I) = -IX(I)
   20    CONTINUE
      ENDIF
C
C     Sort IX only
C
      M = 1
      I = 1
      J = NN
      R = .375E0
C
   30 IF (I .EQ. J) GO TO 80
      IF (R .LE. 0.5898437E0) THEN
         R = R+3.90625E-2
      ELSE
         R = R-0.21875E0
      ENDIF
C
   40 K = I
C
C     Select a central element of the array and save it in location L
C
      IJ = I + INT((J-I)*R)
      LM = IPERM(IJ)
C
C     If first element of array is greater than LM, interchange with LM
C
      IF (IX(IPERM(I)) .GT. IX(LM)) THEN
         IPERM(IJ) = IPERM(I)
         IPERM(I) = LM
         LM = IPERM(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than LM, interchange with LM
C
      IF (IX(IPERM(J)) .LT. IX(LM)) THEN
         IPERM(IJ) = IPERM(J)
         IPERM(J) = LM
         LM = IPERM(IJ)
C
C        If first element of array is greater than LM, interchange
C        with LM
C
         IF (IX(IPERM(I)) .GT. IX(LM)) THEN
            IPERM(IJ) = IPERM(I)
            IPERM(I) = LM
            LM = IPERM(IJ)
         ENDIF
      ENDIF
      GO TO 60
   50 LMT = IPERM(L)
      IPERM(L) = IPERM(K)
      IPERM(K) = LMT
C
C     Find an element in the second half of the array which is smaller
C     than LM
C
   60 L = L-1
      IF (IX(IPERM(L)) .GT. IX(LM)) GO TO 60
C
C     Find an element in the first half of the array which is greater
C     than LM
C
   70 K = K+1
      IF (IX(IPERM(K)) .LT. IX(LM)) GO TO 70
C
C     Interchange these elements
C
      IF (K .LE. L) GO TO 50
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 90
C
C     Begin again on another portion of the unsorted array
C
   80 M = M-1
      IF (M .EQ. 0) GO TO 120
      I = IL(M)
      J = IU(M)
C
   90 IF (J-I .GE. 1) GO TO 40
      IF (I .EQ. 1) GO TO 30
      I = I-1
C
  100 I = I+1
      IF (I .EQ. J) GO TO 80
      LM = IPERM(I+1)
      IF (IX(IPERM(I)) .LE. IX(LM)) GO TO 100
      K = I
C
  110 IPERM(K+1) = IPERM(K)
      K = K-1
C
      IF (IX(LM) .LT. IX(IPERM(K))) GO TO 110
      IPERM(K+1) = LM
      GO TO 100
C
C     Clean up
C
  120 IF (KFLAG .LE. -1) THEN
         DO 130 I=1,NN
            IX(I) = -IX(I)
  130    CONTINUE
      ENDIF
C
C     Rearrange the values of IX if desired
C
      IF (KK .EQ. 2) THEN
C
C        Use the IPERM vector as a flag.
C        If IPERM(I) < 0, then the I-th value is in correct location
C
         DO 150 ISTRT=1,NN
            IF (IPERM(ISTRT) .GE. 0)  THEN
               INDX = ISTRT
               INDX0 = INDX
               ITEMP = IX(ISTRT)
  140          IF (IPERM(INDX) .GT. 0)  THEN
                  IX(INDX) = IX(IPERM(INDX))
                  INDX0 = INDX
                  IPERM(INDX) = -IPERM(INDX)
                  INDX = ABS(IPERM(INDX))
                  GO TO 140
               ENDIF
               IX(INDX0) = ITEMP
            ENDIF
  150    CONTINUE
C
C        Revert the signs of the IPERM values
C
         DO 160 I=1,NN
            IPERM(I) = -IPERM(I)
  160    CONTINUE
C
      ENDIF
C
      RETURN
      END
